/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.jboss.seam.ui.component.html;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.jboss.seam.ui.component.UICache;
import org.jboss.seam.cache.CacheProvider;

/**
 * Cache the rendered page fragment using the installed cache provider.
 **/
@Generated({"RichFaces CDK", "4.3.1.Final-redhat-1"})
public class HtmlCache extends UICache
        {

    public static final String COMPONENT_TYPE="org.jboss.seam.ui.Cache";

    public static final String COMPONENT_FAMILY="org.jboss.seam.ui.Cache";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public HtmlCache() {
        super();
        setRendererType("org.jboss.seam.ui.CacheRenderer");
    }




    protected enum Properties {
        cacheProvider,
        enabled,
        key,
        region
        
    }

 
    public CacheProvider getCacheProvider() {
        CacheProvider value = (CacheProvider) getStateHelper().eval(Properties.cacheProvider, org.jboss.seam.cache.CacheProvider.instance());
        return value;
    }
    
    public void setCacheProvider(CacheProvider cacheProvider) {
        getStateHelper().put(Properties.cacheProvider, cacheProvider);
    }

 
    public boolean isEnabled() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.enabled, true);
        return value;
    }
    
    public void setEnabled(boolean enabled) {
        getStateHelper().put(Properties.enabled, enabled);
    }

 
    public String getKey() {
        String value = (String) getStateHelper().eval(Properties.key);
        return value;
    }
    
    public void setKey(String key) {
        getStateHelper().put(Properties.key, key);
    }

 
    public String getRegion() {
        String value = (String) getStateHelper().eval(Properties.region);
        return value;
    }
    
    public void setRegion(String region) {
        getStateHelper().put(Properties.region, region);
    }

    

}
